SystemOrganization addCategory: #TpObjetos!

Object subclass: #Actividad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Actividad methodsFor: 'Do' stamp: 'owhdf 11/30/2012 22:53'!
realizarActividad:unCurso! !

Actividad subclass: #Alegoria
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Alegoria methodsFor: 'Do' stamp: 'owhdf 11/30/2012 22:57'!
realizarActividad: unCurso
unCurso alumnos do: [:unAlumno | 
		((unAlumno atencion) > 30) 
			ifTrue:
			[unAlumno atencion: ((unAlumno atencion) +10).
			unAlumno motivar]
		
			ifFalse: [unAlumno desanimar; motivar]].! !

Actividad subclass: #Analogia
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Analogia methodsFor: 'Do' stamp: 'owhdf 11/30/2012 22:54'!
realizarActividad: unCurso
unCurso alumnos do: [:unAlumno | 
	((unAlumno atencion) > 30) 
		ifTrue:
		[unAlumno atencion: ((unAlumno atencion) +10).
		unAlumno motivar]
		
		ifFalse: [unAlumno desanimar]].! !

Actividad subclass: #Payasada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Payasada methodsFor: 'Do' stamp: 'owhdf 11/30/2012 22:58'!
realizarActividad: unCurso
unCurso alumnos do: [:unAlumno |
	unAlumno atencion: ((unAlumno atencion) *2).
	unAlumno invertirMotivacion.
	((unAlumno animo) = (Estados mostrarEstados at:4)) ifTrue: [unAlumno animo: (Estados mostrarEstados at:1)]
	ifFalse: [unAlumno animar]].
! !

Actividad subclass: #Receso
	instanceVariableNames: 'tiempo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Receso methodsFor: 'Getters' stamp: 'owhdf 11/30/2012 23:11'!
getTiempo
^tiempo .! !

!Receso methodsFor: 'Do' stamp: 'owhdf 11/30/2012 22:59'!
realizarActividad: unCurso
unCurso alumnos do: [:unAlumno | 
			unAlumno atencion:  ((unAlumno atencion) + self getTiempo ).
			(((unAlumno animo) = (Estados mostrarEstados at:1) | (unAlumno animo) = (Estados mostrarEstados at:2)) & ((unAlumno atencion) < 50)) 
			ifTrue: [unAlumno atencion: ((unAlumno atencion) *2)]
			ifFalse: [unAlumno animar]].! !

!Receso methodsFor: 'Setters' stamp: 'owhdf 11/30/2012 23:11'!
setTiempo: unTiempo
tiempo:=unTiempo .! !

Actividad subclass: #Representacion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Representacion methodsFor: 'as yet unclassified' stamp: 'owhdf 11/30/2012 23:00'!
realizarActividad: unCurso
| alumnosDesmotivados alumnosMotivados estaMotivado seQuierenIr alumnosSeQuierenIr alumnosADesanimar |
	unCurso alumnos do: [:alumno | alumno duplicarAtencion].
	estaMotivado := [:alumno | alumno motivacion].
	alumnosMotivados  := unCurso alumnos select: estaMotivado.
	alumnosDesmotivados :=  unCurso alumnos reject: estaMotivado.
	alumnosMotivados do: [:alumno | alumno desmotivar].
	alumnosDesmotivados do: [:alumno | alumno motivar].
	
	seQuierenIr := [:alumno | alumno estado = 1].
	alumnosSeQuierenIr := unCurso alumnos select: seQuierenIr.
	alumnosADesanimar := unCurso alumnos reject: seQuierenIr.
	alumnosADesanimar do: [:alumno | alumno desanimar].
	alumnosSeQuierenIr  do: [:alumno | alumno estado: 6].! !

Actividad subclass: #Tema
	instanceVariableNames: 'nombre temasPrevios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

Tema subclass: #Complejo
	instanceVariableNames: 'interes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Complejo class methodsFor: 'as yet unclassified' stamp: 'Damian 10/27/2012 15:00'!
new: nombre interes: interes
	|temaComplejo|
	temaComplejo := super new: nombre.
	temaComplejo interes: interes.
	^temaComplejo.! !

!Complejo methodsFor: 'Getters' stamp: 'Damian 10/21/2012 23:14'!
interes
^interes.! !

!Complejo methodsFor: 'Setters' stamp: 'Damian 10/21/2012 23:14'!
interes: unNumero
(unNumero >100) ifTrue: [interes := 100]
ifFalse: [interes := unNumero].! !

Tema subclass: #Simple
	instanceVariableNames: 'estados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Simple class methodsFor: 'as yet unclassified' stamp: 'Damian 10/27/2012 15:54'!
new: nombre estados: estados
	|temaSimple setEstados|
	temaSimple := super new: nombre.
	temaSimple inicializar.
	setEstados := estados asSet.
	temaSimple agregarEstados: estados.
	^temaSimple.! !

!Simple methodsFor: 'Setters' stamp: 'Damian 10/27/2012 15:54'!
agregarEstados: estadosParaAgregar
	estadosParaAgregar do: [:estado | self estadoNum: estado ].! !

!Simple methodsFor: 'Setters' stamp: 'Damian 10/27/2012 15:18'!
estadoNum: unNumero
| unEstado |

(unNumero > (Estados max))
ifTrue: [unEstado := (Estados mostrarEstados at:  (Estados max))]
ifFalse: [(unNumero <1) 
	ifTrue: [unEstado := (Estados mostrarEstados at: 1)] 
	ifFalse: [unEstado := (Estados mostrarEstados at: unNumero)]].

estados add: unEstado.! !

!Simple methodsFor: 'Getters' stamp: 'Damian 10/27/2012 15:06'!
estados
^estados.! !

!Simple methodsFor: 'Setters' stamp: 'Damian 10/27/2012 15:21'!
inicializar
	estados := Set new.! !

!Tema class methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 23:46'!
new: unNombre
	|tema|
	tema := self new.
	tema inicializar: unNombre.
	^tema! !

!Tema methodsFor: 'Setters' stamp: 'Damian 10/21/2012 23:42'!
inicializar: unNombre
	temasPrevios := Set new.
	nombre := unNombre.! !

!Tema methodsFor: 'Getters' stamp: 'LeoComparin 9/25/2012 02:26'!
nombre
^nombre.! !

!Tema methodsFor: 'Setters' stamp: 'LeoComparin 9/25/2012 02:26'!
nombre: unNombre
nombre := unNombre .! !

!Tema methodsFor: 'Do' stamp: 'owhdf 11/30/2012 23:11'!
realizarActividad: unCurso
unCurso teDoy: self nombre .! !

!Tema methodsFor: 'Setters' stamp: 'Damian 10/21/2012 16:32'!
temasPrevios
	^temasPrevios.! !

!Tema methodsFor: 'Setters' stamp: 'Damian 10/29/2012 22:38'!
temasPrevios: temas
	temas do: [:tema | temasPrevios add: tema].! !

Object subclass: #Alumno
	instanceVariableNames: 'nivelAtencion motivacion animo estado temasAprendidos temasImprescindibles calificacion esponja'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

Alumno class
	instanceVariableNames: 'atencion motivacion animo estado temasAprendidos calificacion'!

Alumno class
	instanceVariableNames: 'atencion motivacion animo estado temasAprendidos calificacion'!

!Alumno class methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 21:55'!
new
	|alumno|
	alumno := super new.
	alumno inicializar.
	^alumno.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:58'!
animar
(estado = nil) ifTrue: [self estado: 1].
self animo: (Estados dameEstado: (estado+1)).
self estado: (estado+1).! !

!Alumno methodsFor: 'Getters' stamp: 'Damian 10/27/2012 19:43'!
animo
	^animo.! !

!Alumno methodsFor: 'Setters' stamp: 'Damian 10/27/2012 19:43'!
animo: unEstado
	animo := unEstado.! !

!Alumno methodsFor: 'Do' stamp: 'Damian 10/29/2012 23:30'!
aprender: unTema

((unTema temasPrevios) size = 0) | ((unTema temasPrevios) allSatisfy: [:tema | (self temasAprendidos) includes: tema])

	ifTrue: 
	[(unTema class = Complejo)
		ifTrue: [((nivelAtencion >= (0.9*(unTema interes)) & (motivacion)))
			ifTrue: [temasAprendidos add: unTema.
					self atencion: (nivelAtencion + ((unTema interes)/2) ).
					self motivar.
					self animar]]
		
		ifFalse: [((unTema estados includes: animo) & (nivelAtencion > 50))
			ifTrue: [temasAprendidos add: unTema.
					self atencion: (nivelAtencion + 10).
					self motivar.
					self animar]].
	].! !

!Alumno methodsFor: 'Do' stamp: 'Damian 10/27/2012 19:17'!
aprenderImprescindible: unTema

((unTema class) = Complejo)
	 ifTrue: [((nivelAtencion >= (0.9*(unTema interes)) & (motivacion)))
			ifTrue: [temasAprendidos add: unTema.
					temasImprescindibles add: unTema.
					self atencion: (nivelAtencion + ((unTema interes)/2) ).
					self motivar.
					self animar]]
		
	ifFalse: [((unTema estado = animo) & (nivelAtencion > 50))
			ifTrue: [temasAprendidos add: unTema.
					temasImprescindibles add: unTema.
					self atencion: (nivelAtencion + 10).
					self motivar.
					self animar]].! !

!Alumno methodsFor: 'Getters' stamp: 'Damian 10/27/2012 19:17'!
atencion
^nivelAtencion.! !

!Alumno methodsFor: 'Setters' stamp: 'Damian 10/27/2012 19:17'!
atencion: unNumero
(unNumero >100) ifTrue: [nivelAtencion := 100]
ifFalse: [nivelAtencion := unNumero].! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:00'!
calificacion
^calificacion.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/11/2012 22:48'!
calificacion: unNumero
(unNumero >= 4) 	ifTrue: [calificacion := unNumero]
					ifFalse: [calificacion := 2].
(calificacion = 10)	ifTrue: [esponja := true]
					ifFalse: [esponja := false].! !

!Alumno methodsFor: 'Setters' stamp: 'Damian 10/27/2012 19:39'!
desanimar
	(estado = nil) ifTrue: [self estado: 1].
	self animo: (Estados dameEstado: (estado-1)).
	self estado: (estado-1).! !

!Alumno methodsFor: 'Setters' stamp: 'Damian 10/27/2012 19:39'!
desmotivar
	motivacion := false.! !

!Alumno methodsFor: 'Setters' stamp: 'Damian 10/27/2012 19:16'!
duplicarAtencion
	nivelAtencion := nivelAtencion * 2.! !

!Alumno methodsFor: 'Getters' stamp: 'Damian 10/27/2012 19:39'!
estado
	^estado.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:46'!
estado: unNumero
(unNumero > (Estados max))
ifTrue: [estado := (Estados max)]
ifFalse: [(unNumero <1) 
	ifTrue: [estado := 1] 
	ifFalse: [estado := unNumero]].! !

!Alumno methodsFor: 'Setters' stamp: 'Damian 10/27/2012 19:42'!
inicializar
	|motivacionRand|
	temasAprendidos := Set new.
	temasImprescindibles := Set new.
	nivelAtencion := (1 to: 100) atRandom.
	motivacionRand := (0 to: 1) atRandom.
	estado := (1 to: (Estados max)) atRandom.
	(motivacionRand = 1)
		ifTrue:  [motivacion  := true]
		ifFalse: [motivacion  := false]! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 17:34'!
invertirMotivacion
motivacion :=  motivacion not.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
motivacion
^motivacion.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
motivar
motivacion := true.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 06:34'!
temas
^temasAprendidos.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 19:11'!
temasAprendidos
^temasAprendidos.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 20:02'!
temasImprescindibles
^temasImprescindibles.! !

Object subclass: #Clase
	instanceVariableNames: 'curso'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Clase class methodsFor: 'as yet unclassified' stamp: 'Damian 10/27/2012 18:21'!
para: unCurso
	|unaClase|
	unaClase := self new.
	unaClase curso: unCurso.
	^unaClase.! !

!Clase methodsFor: 'Setters' stamp: 'Demian 10/16/2012 10:15'!
alegoria
	curso alumnos do: [:unAlumno | 
		((unAlumno atencion) > 30) 
			ifTrue:
			[unAlumno atencion: ((unAlumno atencion) +10).
			unAlumno motivar]
		
			ifFalse: [unAlumno desanimar; motivar]].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:25'!
analogia
curso alumnos do: [:unAlumno | 
	((unAlumno atencion) > 30) 
		ifTrue:
		[unAlumno atencion: ((unAlumno atencion) +10).
		unAlumno motivar]
		
		ifFalse: [unAlumno desanimar]].! !

!Clase methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 19:07'!
curso
^curso.! !

!Clase methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:54'!
curso: unCurso
curso := unCurso.! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:41'!
diapositivas
"Explicar un tema mediante diapositivas. Aumenta la atencion de todo el curso un 20%, pero si el alumno se quiere ir o esta mas o menos se desmotiva"

curso alumnos do: [:unAlumno | 
	((unAlumno animo = (Estados mostrarEstados at: 1)) | (unAlumno animo = (Estados mostrarEstados at: 2))) 	ifTrue: [unAlumno desmotivar].
	unAlumno atencion: ((unAlumno atencion)*1.2)].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/11/2012 01:10'!
ejercitar
"Dar ejercicios para resolver en clase. Si el alumno esta motivado mejora su estado de animo y su nivel de atencion sube a 80 a menos que sea mayor, en ese caso queda igual. 
En caso contrario, si el alumno esta desmotivado, automaticamente quiere irse y su nivel de atencion baja a un 30% de este"

curso alumnos do: [:unAlumno | 
	(unAlumno motivacion) 
	ifTrue: [unAlumno animar.
	(unAlumno atencion <80) ifTrue: [unAlumno atencion: 80]]

	ifFalse: [unAlumno animo: (Estados mostrarEstados at: 1).
	unAlumno atencion: (unAlumno atencion)*0.3]].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/23/2012 19:34'!
ejercitarCon: unTema
"Dar ejercicios de un tema para resolver en clase. Si el alumno esta motivado mejora su estado de animo y su nivel de atencion sube a 80 a menos que sea mayor, en ese caso queda igual. 
En caso contrario, si el alumno esta desmotivado, automaticamente quiere irse y su nivel de atencion baja a un 30% de este"

curso alumnos do: [:unAlumno | 
	(unAlumno motivacion) 
	ifTrue: [unAlumno animar.
	(unAlumno atencion <80) ifTrue: [unAlumno atencion: 80]]

	ifFalse: [unAlumno animo: (Estados mostrarEstados at: 1).
	unAlumno atencion: (unAlumno atencion)*0.3]].
curso teDoy: unTema.! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:38'!
explicar: unTema
curso teDoy: unTema.! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:38'!
explicarImprescindible: unTema
curso teDoyImp: unTema.! !

!Clase methodsFor: 'Setters' stamp: 'Demian 10/16/2012 11:07'!
hacerRepresentacion
	| alumnosDesmotivados alumnosMotivados estaMotivado seQuierenIr alumnosSeQuierenIr alumnosADesanimar |
	curso alumnos do: [:alumno | alumno duplicarAtencion].
	estaMotivado := [:alumno | alumno motivacion].
	alumnosMotivados  := curso alumnos select: estaMotivado.
	alumnosDesmotivados :=  curso alumnos reject: estaMotivado.
	alumnosMotivados do: [:alumno | alumno desmotivar].
	alumnosDesmotivados do: [:alumno | alumno motivar].
	
	seQuierenIr := [:alumno | alumno estado = 1].
	alumnosSeQuierenIr := curso alumnos select: seQuierenIr.
	alumnosADesanimar := curso alumnos reject: seQuierenIr.
	alumnosADesanimar do: [:alumno | alumno desanimar].
	alumnosSeQuierenIr  do: [:alumno | alumno estado: 6].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:43'!
payasada
curso alumnos do: [:unAlumno |
	unAlumno atencion: ((unAlumno atencion) *2).
	unAlumno invertirMotivacion.
	((unAlumno animo) = (Estados mostrarEstados at:4)) ifTrue: [unAlumno animo: (Estados mostrarEstados at:1)]
	ifFalse: [unAlumno animar]].
! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:46'!
receso: unTiempo
curso alumnos do: [:unAlumno | 
			unAlumno atencion:  ((unAlumno atencion) + unTiempo).
			(((unAlumno animo) = (Estados mostrarEstados at:1) | (unAlumno animo) = (Estados mostrarEstados at:2)) & ((unAlumno atencion) < 50)) 
			ifTrue: [unAlumno atencion: ((unAlumno atencion) *2)]
			ifFalse: [unAlumno animar]].! !

Object subclass: #Curso
	instanceVariableNames: 'alumnos docente clase temasVistos temasImprescindibles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Curso class methodsFor: 'as yet unclassified' stamp: 'Damian 10/27/2012 18:40'!
en: facultad
	| unCurso unaClase|
	unCurso  := self new.
	unCurso comenzarCurso.
	unaClase := Clase para: unCurso.
	unCurso clase: unaClase.
	facultad agregar: unCurso.
	^unCurso.! !

!Curso methodsFor: 'Setters' stamp: 'Damian 10/29/2012 22:27'!
agregarTema: tema
	self temasVistos add: tema.! !

!Curso methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:09'!
alumnos
^alumnos.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/11/2012 21:02'!
aprobados
| aprobados |

aprobados := (alumnos select: [:alum | alum calificacion >=4])size.
(alumnos size >0) ifTrue: [^(aprobados/(alumnos size)*100)asFloat].! !

!Curso methodsFor: 'Setters' stamp: 'Damian 10/27/2012 18:49'!
clase
	^clase.! !

!Curso methodsFor: 'Setters' stamp: 'Damian 10/27/2012 18:24'!
clase: unaClase
	clase := unaClase.! !

!Curso methodsFor: 'Setters' stamp: 'Damian 10/29/2012 23:50'!
comenzarCurso
	alumnos := Set new.
	temasVistos := OrderedCollection new.
	temasImprescindibles := Set new.! !

!Curso methodsFor: 'Getters' stamp: 'Damian 10/27/2012 19:31'!
docente
	^docente.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/11/2012 21:04'!
evaluacion
	| materias totales |

totales := (docente temasTotales size).
alumnos do: [:unAlumno | materias := (unAlumno temasAprendidos size).
			((unAlumno temasImprescindibles size ) = (temasImprescindibles size)) ifTrue: 
			[unAlumno calificacion: (( materias / totales ) * 10)asFloat]
	
			ifFalse: [unAlumno calificacion: 2]].! !

!Curso methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:15'!
inscribir: unAlumno
alumnos add: unAlumno.! !

!Curso methodsFor: 'Setters' stamp: 'Demian 11/10/2012 12:48'!
porcAprendizaje: tema
	^ ((self alumnos select: [:alumno | alumno temasAprendidos includes: tema ]) size / self alumnos size).! !

!Curso methodsFor: 'Do' stamp: 'Damian 10/27/2012 19:30'!
teDoy: unTema
	alumnos do: [:unAlumno| unAlumno aprender: unTema].
	docente agregarTema: unTema.
	temasVistos add: unTema.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:32'!
teDoyImp: unTema
alumnos do: [:unAlumno| unAlumno aprenderImprescindible: unTema].
docente agregarTema: unTema.
temasVistos add: unTema.
temasImprescindibles add: unTema.
! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:20'!
temaMenosAprendido
| ordenados |

ordenados := docente temasTotales asSortedCollection: [:a :b | (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: a)]) <  (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: b)])].

(ordenados size >=1)
ifTrue: [ ^ ordenados first nombre] .! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:30'!
temaMenosAprendidoVarias
| ordenados varios|

varios := temasVistos select: [:unTema | (temasVistos occurrencesOf: unTema ) >1].

ordenados := varios asSortedCollection: [:a :b | (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: a)]) <  (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: b)])].

(ordenados size >=1)
ifTrue: [ ^ ordenados first nombre] .! !

!Curso methodsFor: 'Getters' stamp: 'Damian 10/29/2012 23:57'!
temasVistos
	^temasVistos.! !

!Curso methodsFor: 'Setters' stamp: 'Damian 10/27/2012 19:31'!
tuDocenteEs: unDocente
	docente := unDocente.! !

!Curso methodsFor: 'Getters' stamp: 'Demian 10/19/2012 12:21'!
ultimoTemaVisto
	^ self temasVistos last.! !

Object subclass: #Docente
	instanceVariableNames: 'temasTotales temasIndispensables planificacionTemas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Docente class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/23/2012 03:24'!
new
| unDocente |

unDocente := super new.
unDocente comenzarCurso.
^unDocente.! !

!Docente methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:44'!
agregarTema: unTema
temasTotales add: unTema.! !

!Docente methodsFor: 'Setters' stamp: 'Damian 10/29/2012 23:41'!
comenzarCurso
	temasTotales := Set new.
	planificacionTemas := OrderedCollection new.! !

!Docente methodsFor: 'Getters' stamp: 'Damian 10/27/2012 18:46'!
cursosEn: facultad
	^ ((facultad cursos) select: [:curso | curso docente = self])! !

!Docente methodsFor: 'Setters' stamp: 'Damian 10/21/2012 16:57'!
planificacionTemas
	^planificacionTemas.! !

!Docente methodsFor: 'Setters' stamp: 'Damian 10/29/2012 23:36'!
planificacionTemas: temas
	temas do: [:tema | planificacionTemas add: tema].! !

!Docente methodsFor: 'Setters' stamp: 'Damian 10/21/2012 16:56'!
temasIndispensables
	^temasIndispensables! !

!Docente methodsFor: 'Setters' stamp: 'Damian 10/21/2012 17:18'!
temasIndispensables: temas
	temasIndispensables:= temas! !

!Docente methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 19:15'!
temasTotales
^temasTotales.! !

!Docente methodsFor: 'Getters' stamp: 'Damian 10/21/2012 17:17'!
temasTotales: temas 
	temasTotales:= temas.
! !

Docente subclass: #Estructurado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Estructurado methodsFor: 'Do' stamp: 'LeoComparin 10/23/2012 18:32'!
capacitarse
	|piola|
	piola := Piola new.
	self primitiveChangeClassTo: piola.
! !

!Estructurado methodsFor: 'Do' stamp: 'Damian 10/29/2012 22:23'!
darClasesEn: facultad
	| cursosDocente temaClase |
	temaClase :=  planificacionTemas remove: (planificacionTemas first).
	cursosDocente := self cursosEn: facultad.
	cursosDocente do: [:curso | (curso clase) explicar: temaClase; receso: facultad tiempoRecesos; ejercitar].! !

Docente subclass: #Piola
	instanceVariableNames: 'porcentajeSuficiente recesos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Piola class methodsFor: 'as yet unclassified' stamp: 'Demian 11/14/2012 00:21'!
new: tiempoRecesos
	|piola|
	piola := super new.
	piola porcentajeSuficiente: 0.3.
	piola tiempoRecesos: tiempoRecesos.
	^piola.! !

!Piola methodsFor: 'Do' stamp: 'Demian 11/14/2012 00:08'!
darClasesEn: facultad
	| cursosDocente ultimoTema temaClase recurso |
	cursosDocente := self cursosEn: facultad.
	cursosDocente do: 
		[:curso | 
		((curso temasVistos) size > 0)
		ifTrue: [
		((curso porcAprendizaje: (curso ultimoTemaVisto)) < self porcentajeSuficiente)
			ifTrue: [(curso clase) analogia; explicar: ultimoTema]
			ifFalse: [(curso clase) ejercitar; alegoria].
		(curso clase) receso: (self tiempoRecesos)].
		(self planificacionTemas size > 0)
		ifTrue: [
			temaClase :=  planificacionTemas remove: (planificacionTemas first).
			(curso clase) explicar: temaClase.
			(curso clase) ejercitar.]
		].! !

!Piola methodsFor: 'Do' stamp: 'LeoComparin 10/23/2012 18:41'!
estructurarse
	| trad |
	trad := Estructurado new.
	self primitiveChangeClassTo: trad.
! !

!Piola methodsFor: 'Do' stamp: 'Demian 11/10/2012 12:21'!
porcentajeSuficiente
	^porcentajeSuficiente.! !

!Piola methodsFor: 'Do' stamp: 'Demian 11/10/2012 12:16'!
porcentajeSuficiente: porcentaje
	porcentajeSuficiente := porcentaje.! !

!Piola methodsFor: 'Do' stamp: 'Demian 11/10/2012 16:07'!
tiempoRecesos 
	^recesos.! !

!Piola methodsFor: 'Do' stamp: 'Demian 11/10/2012 16:08'!
tiempoRecesos: mins
	recesos := mins.! !

Object subclass: #Estados
	instanceVariableNames: ''
	classVariableNames: 'Estados Max'
	poolDictionaries: ''
	category: 'TpObjetos'!

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:47'!
dameEstado: unNumero
(unNumero > Max)
ifTrue: [^Estados at: Max]
ifFalse: [(unNumero <1) 
	ifTrue: [^Estados at: 1] 
	ifFalse: [^Estados at: unNumero]].! !

!Estados class methodsFor: 'as yet unclassified' stamp: 'Damian 10/27/2012 19:38'!
iniciarEstados
Estados := OrderedCollection new.
Estados add: 'me quiero ir'.
Estados add: 'que mal la estoy pasando'.
Estados add: 'mas o menos'.
Estados add: 'todo bien'.
Estados add: 'muy bien'.
Estados add: 'con ganas de ser ayudante'.
Max := Estados size.! !

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:43'!
max
^Max.! !

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:33'!
mostrarEstados
^Estados.! !

Object subclass: #Facultad
	instanceVariableNames: 'cursos tiempoRecesos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

Facultad class
	instanceVariableNames: 'cursos'!

Facultad class
	instanceVariableNames: 'cursos'!

!Facultad class methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 23:26'!
new
	| facultad |
	facultad := super new.
	facultad inicializar.
	^facultad! !

!Facultad methodsFor: 'Setters' stamp: 'Damian 10/27/2012 18:27'!
agregar: unCurso
	cursos add: unCurso.! !

!Facultad methodsFor: 'Getters' stamp: 'Damian 10/27/2012 18:27'!
cursos
	^cursos.! !

!Facultad methodsFor: 'Setters' stamp: 'Damian 10/27/2012 18:27'!
inicializar
	cursos := Set new.
	tiempoRecesos := 20.! !

!Facultad methodsFor: 'Do' stamp: 'Damian 10/21/2012 23:30'!
invertir: tema
	tema class = Complejo 
	ifTrue:  [^true].! !

!Facultad methodsFor: 'Getters' stamp: 'Demian 10/18/2012 14:26'!
tiempoRecesos
	^tiempoRecesos.! !
